package com.dwl.mindoc.service;

import com.dwl.mindoc.MinConfig;
import com.dwl.mindoc.database.Database;
import com.dwl.mindoc.database.impl.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DBGenerDocService {
    @Autowired
    private MinConfig config;

    private enum BaseType{

        MySQL,Oracle,PostgreSQL,SQLite,SQLServer

    }


    /**
     * 获取数据库信息
     * @return
     */
    public Database getDataBase() throws Exception {
        Database dataBase = null;
        String baseType = config.getValue("baseType");
        String baseName = config.getValue("baseName");
        BaseType type =BaseType.valueOf(baseType);
        switch (type) {
            case MySQL:
                dataBase = new MySQL(baseName);
                break;
            case Oracle:
                dataBase = new Oracle(baseName);
                break;
            case PostgreSQL:
                dataBase = new PostgreSQL();
                break;
            case SQLite:
                dataBase = new SQLite();
                break;
            case SQLServer:
                dataBase = new SQLServer(baseName);
                break;
            default:
                throw new Exception("Not Support BaseType: "+baseType);
        }
        return dataBase;
    }
}
